//============================================================================
// SMI^XN
//
// (c)2021 Micon-Giken
//============================================================================
#include "kernel.h"
#include "task_smi.h"

//============================================================================
// `.
//============================================================================

//============================================================================
// vg^Cv.
//============================================================================
void SMI_subclk(int data, int n);

//============================================================================
// f[^.
//============================================================================

//============================================================================
// API֐.
//============================================================================

//---------------------------------------------------------------------
// SMIhCoE^XN.
void SMI_init() {
	
	//|[gݒ.
	PORT_mode_in(SMI_MDIO);
	PORT_mode_out(SMI_MDC, 1);

//	start_task(SMI_taskid, SMI_init1);
}

//============================================================================
// ^XNA又.
//============================================================================

//============================================================================
// [J֐.
//============================================================================

//----------------------------------------------------------------------------
// SPIM.
void SMI_tx(int phy_addr, int reg_addr, int data) {
	//z
	PORT_outclr(SMI_MDC); __nop(); 	__nop();
	PORT_outset(SMI_MDC); __nop();

	//start write(0110),phy_addr,reg_addr, ta(10), data)
	PORT_mode_out(SMI_MDIO, 0);
	PORT_outclr(SMI_MDC); __nop(); 	__nop();
	PORT_outset(SMI_MDC);
	SMI_subclk(6, 3);
	SMI_subclk(phy_addr, 5);
	SMI_subclk(reg_addr, 5);
	SMI_subclk(2, 2);
	SMI_subclk(data, 16);
	
	//z
	PORT_mode_in(SMI_MDIO);
	PORT_outclr(SMI_MDC); __nop(); 	__nop();
	PORT_outset(SMI_MDC);
}
int  SMI_rx(int phy_addr, int reg_addr) {
	int i, j = 0x8000, k = 0;
	//z
	PORT_outclr(SMI_MDC); __nop(); 	__nop();
	PORT_outset(SMI_MDC); __nop();

	//start write(0101),phy_addr,reg_addr, ta(10), data)
	PORT_mode_out(SMI_MDIO, 0);
	PORT_outclr(SMI_MDC); __nop(); 	__nop();
	PORT_outset(SMI_MDC);
	SMI_subclk(5, 3);
	SMI_subclk(phy_addr, 5);
	SMI_subclk(reg_addr, 5);
	//z
	PORT_mode_in(SMI_MDIO);
	PORT_outclr(SMI_MDC); __nop(); 	__nop();
	PORT_outset(SMI_MDC); __nop(); 	__nop();
	PORT_outclr(SMI_MDC); __nop(); 	__nop();
	PORT_outset(SMI_MDC);
	//data
	for (i = 0; i < 16; i++) {
		PORT_outclr(SMI_MDC);
		if (PORT_inchkbit(SMI_MDIO)) k += j;
		PORT_outset(SMI_MDC);
		j >>= 1;
	}
	//z
	PORT_outclr(SMI_MDC); __nop(); 	__nop();
	PORT_outset(SMI_MDC);
	
	return k;
}

void SMI_subclk(int data, int n) {
	int i, j = 1;
	j <<= n - 1;
	for (i = 0; i < n; i++) {
		if (data & j)	PORT_outset(SMI_MDIO);
		else			PORT_outclr(SMI_MDIO);
		PORT_outclr(SMI_MDC); __nop(); 	__nop();
		PORT_outset(SMI_MDC);
		j >>= 1;
	}
}

//============================================================================
// nh.
//============================================================================


//============================================================================
