//============================================================================
// USB(CDC)pwb_
//
// (c)2021 Micon-Giken
//============================================================================
#ifndef TASK_USB_H
#define TASK_USB_H

#include <stdio.h>
#include <stdint.h>
#include <stdbool.h>
#include <stddef.h>
#include <stdlib.h>
#include "configuration.h"
#include "definitions.h"

//============================================================================
// `.
//============================================================================
#define USB_BAUDRATE		460800		// {[[gI(19200--921600).
#if   STDIO_VERSION == 1
#define USB_SEND_SIZE		256			// Mobt@TCY.
#define USB_RECV_SIZE		256			// Mobt@TCY.
#elif STDIO_VERSION == 2
#define USB_SEND_SIZE		256			// Mobt@TCY. 256Œ. ύXs.
#define USB_RECV_SIZE		256			// Mobt@TCY. 256Œ. ύXs.
#endif

//============================================================================
// API֐.
//============================================================================
// USB(CDC)I[v֐
FILE* USB_open(const char *name, const char *mode);

//----------------------------------------------------------------------------
// USB(CDC)N[Y֐
int USB_close(void *fp);

//----------------------------------------------------------------------------
// USB(CDC)hCoE^XN.
void USB_init(void);

//============================================================================
#endif	/* TASK_USB_H */
