//============================================================================
// foCXiNbNA|[gj
//
// (c)2021 Micon-Giken
//============================================================================
#include "common.h"
#include "device.h"

//============================================================================
// `.
//============================================================================
extern uint _stack;							// JV{ (=RAMŏIԒn-15).
extern uint _min_stack_size;				// JEIvVŎw肵l.
#define DEVICE_STACK_PATT	(0xa5693c1e)	// X^bNʒpp^[.

//============================================================================
// vg^Cv.
//============================================================================

//============================================================================
// f[^.
//============================================================================
static uchar DEVICE_reset_code;			// Zbgvۑp(Ô).

//============================================================================
// API֐.
//============================================================================
//NbNA|[g.
void DEVICE_init(void) {
	ulonglong wk_reg;
	uint z, zc;
	uint *p, *q;

	//------------------------------------------------------------------------
	// Zbgvۑ(Ô).
	//------------------------------------------------------------------------
		DEVICE_reset_code = _reg(RSTC, RCAUSE);

	//------------------------------------------------------------------------
	// IV[^(OSC48MȊO)APLLݒ.
	//------------------------------------------------------------------------
	// Lu[VEf[^擾.
		wk_reg = *(ulonglong*) 0x806020;		//Lu[VEf[^.

	//------------------------------------------------------------------------
	//32kHzOSCݒ.
#if O32_FREQUENCY > 0
		z = _bit(OSC32KCTRL, OSC32K, CALIB);	//Lu[VݒlmF.
		zc = _val(OSC32KCTRL, OSC32K, CALIB, (wk_reg >> 12) & 0x7F);		//ݒ肷ׂf[^.
		if (z != zc) {
			//while(1);	 //fobO
		}
		_reg(OSC32KCTRL, OSC32K) = zc |
			_val(OSC32KCTRL, OSC32K, ENABLE, 1) |
			_val(OSC32KCTRL, OSC32K, EN32K, 1) |
			_val(OSC32KCTRL, OSC32K, ONDEMAND, 0) ;		//펞U.
		while (!_bit(OSC32KCTRL, STATUS, OSC32KRDY));
//		while(1);  //fobO
#endif
			
	//------------------------------------------------------------------------
	// O32kHzݒ.
#if X32_FREQUENCY > 0
		_reg(OSC32KCTRL, XOSC32K) =
			_val(OSC32KCTRL, XOSC32K, STARTUP, OSC32KCTRL_XOSC32K_STARTUP_CYCLE16384_Val) |
			_val(OSC32KCTRL, XOSC32K, XTALEN, 1) |
			_val(OSC32KCTRL, XOSC32K, ENABLE, 1) |
			_val(OSC32KCTRL, XOSC32K, EN32K,  1) |
			_val(OSC32KCTRL, XOSC32K, ONDEMAND, 0) ;	//펞U.
		while (!_bit(OSC32KCTRL, STATUS, XOSC32KRDY));
//		while(1);  //fobO
#endif
			
	//------------------------------------------------------------------------
	// OUݒ.
#if XOSC_FREQUENCY > 0
		// mF
#endif
			
	//------------------------------------------------------------------------
	// PLLݒ.
#if		PLL_FREQUENCY > 0
		_reg(OSCCTRL, DPLLRATIO) =
			_val(OSCCTRL, DPLLRATIO, LDR, 1463) |		//48MHzݒ.
			_val(OSCCTRL, DPLLRATIO, LDRFRAC, 14);		//48MHzݒ.
		while (_bit(OSCCTRL, DPLLSYNCBUSY, DPLLRATIO));
		
#if		(VCO_FREQUENCY / PLL_FREQUENCY) == 1
//		_reg(OSCCTRL, DPLLPRESC) = OSCCTRL_DPLLPRESC_PRESC_DIV1;
#elif	(VCO_FREQUENCY / PLL_FREQUENCY) == 2
		_reg(OSCCTRL, DPLLPRESC) = OSCCTRL_DPLLPRESC_PRESC_DIV2;
#else
		_reg(OSCCTRL, DPLLPRESC) = OSCCTRL_DPLLPRESC_PRESC_DIV4;
#endif
		while (_bit(OSCCTRL, DPLLSYNCBUSY, DPLLPRESC));
		
		_reg(OSCCTRL, DPLLCTRLA) =
			_val(OSCCTRL, DPLLCTRLA, ENABLE, 1) |
			_val(OSCCTRL, DPLLCTRLA, ONDEMAND, 0) ;		//펞U.
		while (_bit(OSCCTRL, DPLLSYNCBUSY, ENABLE));
		while ((_reg(OSCCTRL, DPLLSTATUS) & 0x3) != 0x3);
//		while(1);  //fobO
#endif
		  
	//------------------------------------------------------------------------
	// [hEGCgݒiŜ߂ɐɕύXj (for SAMC2x).
	//------------------------------------------------------------------------
#if CPU_FREQUENCY > 38000000
		_set(NVMCTRL, CTRLB, RWS, 2);		//l0Ȃ̂set.
#elif CPU_FREQUENCY > 20000000 || \
	  CPU_FREQUENCY > 19000000 && VDD_VOLTAGE != 5
		_set(NVMCTRL, CTRLB, RWS, 1);		//l0Ȃ̂set.
#else
		// No wait
#endif

	//------------------------------------------------------------------------
	// CPUNbNύXAIV[^ύX.
	//------------------------------------------------------------------------
	// NbNWFl[^OݒiCPUAoXpBŜ߂ɐɕύXj.
#if CPU_CLOCK_SRC == _src(XOSC)
#define GCLK0_SRC_FREQUENCY		XOSC_FREQUENCY
#elif CPU_CLOCK_SRC == _src(DPLL96M)
#define GCLK0_SRC_FREQUENCY		PLL_FREQUENCY
#elif (OSC_FREQUENCY / CPU_FREQUENCY) > 1
#define GCLK0_SRC_FREQUENCY		OSC_FREQUENCY
#else
#define GCLK0_SRC_FREQUENCY		0
#endif

#if (GCLK0_SRC_FREQUENCY / CPU_FREQUENCY) > 1 || CPU_CLOCK_SRC != _src(OSC48M)
	_reg(GCLK, GENCTRL)[0] =
		_val(GCLK, GENCTRL, DIV, GCLK0_SRC_FREQUENCY / CPU_FREQUENCY) |
		_val(GCLK, GENCTRL, GENEN, 1) |
		_val(GCLK, GENCTRL, SRC, CPU_CLOCK_SRC) ;
	while (_bit(GCLK, SYNCBUSY, GENCTRL0));
#endif

	//------------------------------------------------------------------------
	// 48MHzOSCݒ.
		z = _reg(OSCCTRL, CAL48M);				//Lu[VݒlmF.
#if VDD_VOLTAGE == 5
		zc = (wk_reg >> 19) & 0x3FFFFF;			//ݒ肷ׂf[^(WX^S).
#else
		zc = (wk_reg >> 41) & 0x3FFFFF;
#endif
		if (z != zc) {		//`bv Rev==D̏ꍇ̂ݗL.
			_reg(OSCCTRL, CAL48M) = zc;			//Lu[VXV.
			while(1);
		}
		
#if OSC_FREQUENCY == 0
		_reg(OSCCTRL, OSC48MCTRL) = 0;
#elif OSC_FREQUENCY != 4000000
		_reg(OSCCTRL, OSC48MDIV) = (48000000 / OSC_FREQUENCY - 1);
		while (_bit(OSCCTRL, OSC48MSYNCBUSY, OSC48MDIV));	//҂.
#endif
			
	//------------------------------------------------------------------------
	// NbNWFl[^PtoWݒ.
	//------------------------------------------------------------------------
	// GCLK1	NbNo͊mFpiPA15ój.
			// task_clock.cŐݒ.
			
	//------------------------------------------------------------------------
	// GCLK2	1MHzo͗p(BASE_FREQUENCY)iTC0,TC1pj.
#if BASE_CLOCK_SRC == _src(XOSC)
#define GCLK2_SRC_FREQUENCY		XOSC_FREQUENCY
#elif BASE_CLOCK_SRC == _src(DPLL96M)
#define GCLK2_SRC_FREQUENCY		PLL_FREQUENCY
#else	//SRC_OSC48MƌȂ.
#define GCLK2_SRC_FREQUENCY		OSC_FREQUENCY
#endif
		_reg(GCLK, GENCTRL)[2] =
			_val(GCLK, GENCTRL, DIV, GCLK2_SRC_FREQUENCY / BASE_FREQUENCY) |
			_val(GCLK, GENCTRL, GENEN, 1) |
			_val(GCLK, GENCTRL, SRC, BASE_CLOCK_SRC) ;
		while (_bit(GCLK, SYNCBUSY, GENCTRL2));
		
	//------------------------------------------------------------------------
	// GCLK3	UARTp(6̔{MHz).
#if UART_CLOCK_SRC == _src(XOSC)
#define GCLK3_SRC_FREQUENCY		XOSC_FREQUENCY
#elif UART_CLOCK_SRC == _src(DPLL96M)
#define GCLK3_SRC_FREQUENCY		PLL_FREQUENCY
#else	//SRC_OSC48MƌȂ.
#define GCLK3_SRC_FREQUENCY		OSC_FREQUENCY
#endif
		_reg(GCLK, GENCTRL)[3] =
			_val(GCLK, GENCTRL, DIV, GCLK3_SRC_FREQUENCY / UART_FREQUENCY) |
			_val(GCLK, GENCTRL, GENEN, 1) |
			_val(GCLK, GENCTRL, SRC, UART_CLOCK_SRC) ;
		while (_bit(GCLK, SYNCBUSY, GENCTRL3));
		
	//------------------------------------------------------------------------
	// GCLK4	CANp(8̔{MHz).
#if CAN_CLOCK_SRC == _src(XOSC)
#define GCLK4_SRC_FREQUENCY		XOSC_FREQUENCY
#elif CAN_CLOCK_SRC == _src(DPLL96M)
#define GCLK4_SRC_FREQUENCY		PLL_FREQUENCY
#else	//SRC_OSC48MƌȂ.
#define GCLK4_SRC_FREQUENCY		OSC_FREQUENCY
#endif
		_reg(GCLK, GENCTRL)[4] =
			_val(GCLK, GENCTRL, DIV, GCLK4_SRC_FREQUENCY / CAN_FREQUENCY) |
			_val(GCLK, GENCTRL, GENEN, 1) |
			_val(GCLK, GENCTRL, SRC, CAN_CLOCK_SRC) ;
		while (_bit(GCLK, SYNCBUSY, GENCTRL4));

	//------------------------------------------------------------------------
	// GCLK5	fBp.
#if BEEP_CLOCK_SRC == _src(XOSC)
#define GCLK5_SRC_FREQUENCY		XOSC_FREQUENCY
#elif BEEP_CLOCK_SRC == _src(DPLL96M)
#define GCLK5_SRC_FREQUENCY		PLL_FREQUENCY
#else	//SRC_OSC48MƌȂ.
#define GCLK5_SRC_FREQUENCY		OSC_FREQUENCY
#endif
		_reg(GCLK, GENCTRL)[5] =
			_val(GCLK, GENCTRL, DIV, GCLK5_SRC_FREQUENCY / BEEP_FREQUENCY) |
			_val(GCLK, GENCTRL, GENEN, 1) |
			_val(GCLK, GENCTRL, SRC, BEEP_CLOCK_SRC) ;
		while (_bit(GCLK, SYNCBUSY, GENCTRL5));
		
	//------------------------------------------------------------------------
	// GCLK6	.
	
	//------------------------------------------------------------------------
	// GCLK7	NbNo͊mFpiPB13ójɕύX.
	
	//------------------------------------------------------------------------
	// GCLK8	.
			
	//------------------------------------------------------------------------
	// |[gݒigp|[gŏo͎ݒ肷|[g̐ݒj.
	//------------------------------------------------------------------------
	// Nothing.

	//------------------------------------------------------------------------
	// X[vE[hݒ.
	//------------------------------------------------------------------------
	_reg(PM,SLEEPCFG) = PM_SLEEPCFG_SLEEPMODE_IDLE;			// IDLE (CPUуoX̂stop).

	//------------------------------------------------------------------------
	// EIb`hbOJn.
	//------------------------------------------------------------------------
	_reg(WDT, CONFIG) = WDT_CONFIG_PER_CYC1024;				//1b.
	_set(WDT, CTRLA, ENABLE, 1);							//1bito.

	//------------------------------------------------------------------------
	// X^bN̈揉(ʒp).
	//------------------------------------------------------------------------
#if DEVICE_STACK_PATT > 0
	p = &_stack - ((uint)&_min_stack_size)/4;
	q = &_stack - 64;
	while (p < q) *p++ = DEVICE_STACK_PATT;
#endif
}

//----------------------------------------------------------------------------
// X^bNʎ擾.
#if DEVICE_STACK_PATT > 0
int	 DEVICE_stack(void) {
	uint *p, *q;
	p = &_stack - ((uint)&_min_stack_size)/4;
	q = &_stack - 64;
	while (*p == DEVICE_STACK_PATT && p++ < q);
	return (char*)&_stack - (char*)p;
}
#endif

//----------------------------------------------------------------------------
//EIb`hbOEZbgo(EOF:o).
int	 DEVICE_det_wdt(void){
	if (DEVICE_reset_code & _val(RSTC, RCAUSE, WDT, 1)) return EOF;
	return 0;
}

//============================================================================
// ^XNA又.
//============================================================================

//============================================================================
// [J֐.
//============================================================================

//============================================================================
// nh.
//============================================================================

//============================================================================
