//============================================================================
// NbNj^
//
// (c)2021 Micon-Giken
//============================================================================
#include "kernel.h"
#include "task_clock.h"

//============================================================================
// `.
//============================================================================

//============================================================================
// vg^Cv.
//============================================================================

//============================================================================
// f[^.
//============================================================================

//============================================================================
// API֐.
//============================================================================
//NbNEj^.
void CLOCK_init(void) {
}

// NbNEj^o.
void CLOCK_output(int src, int divsel, int div) {

	//GCLKo͐ݒ
	PORT_mode_out(CLOCK_PIN, 0);
	PORT_peri(CLOCK_PIN, CLOCK_MAPPING);

	//GCLKݒ
#if (TARGET_BOARD & SAMD21_ALL)
	_reg(GCLK, GENDIV) =
		_val(GCLK, GENDIV, ID, CLOCK_GCLK)	|
		_val(GCLK, GENDIV, DIV, div);
	_reg(GCLK, GENCTRL) =
		_val(GCLK, GENCTRL, ID, CLOCK_GCLK) |
		_val(GCLK, GENCTRL, DIVSEL, divsel) |
		_val(GCLK, GENCTRL, OE, 1)			|		//o͂Lɂ.
		_val(GCLK, GENCTRL, GENEN, 1)		|		//WFl[^Lɂ.
		_val(GCLK, GENCTRL, SRC, src) ;
#else
	_reg(GCLK, GENCTRL)[CLOCK_GCLK] =
			_val(GCLK, GENCTRL, SRC, src) |
			_val(GCLK, GENCTRL, DIVSEL, divsel) |
			_val(GCLK, GENCTRL, DIV, div) |
			_val(GCLK, GENCTRL, OE, 1) |			//o͂Lɂ.
			_val(GCLK, GENCTRL, GENEN, 1) ;			//WFl[^Lɂ.
#endif
}

// NbNEj^~.
void CLOCK_close(void) {

#if 1
	PORT_peri_off(CLOCK_PIN);
#else
	PORT_mode_off(CLOCK_PIN);
#endif

#if (TARGET_BOARD & SAMD21_ALL)
	_reg(GCLK, GENCTRL) = _val(GCLK, GENCTRL, ID, CLOCK_GCLK);
#else
	_reg(GCLK, GENCTRL)[CLOCK_GCLK] = 0;
#endif
}

//============================================================================
// ^XNA又.
//============================================================================

//============================================================================
// [J֐.
//============================================================================

//============================================================================
// nh.
//============================================================================

//============================================================================
