//============================================================================
// XCb`̓^XN
//
// (c)2021 Micon-Giken
//============================================================================
#include "kernel.h"
#include "task_sw.h"

//============================================================================
// `.
//============================================================================
#define SW_DETECT				2		// v.

typedef struct {						// SWf[^\.
	int		data;							// SW(ANeBuH).
	int		change;							// ω_.
	int		pre_code;						// Omp^[.
	int		pre_det;						// O񌟏op^[.
	int		count;							// o.
} SW_DATA;

//============================================================================
// vg^Cv.
//============================================================================
void SW_main(void);							// SW^XN(又).

//============================================================================
// f[^.
//============================================================================
static SW_DATA		last_data;				// ŐV.
#define prev_code	last_data.pre_code
#define prev_detect last_data.pre_det
#define count		last_data.count

//============================================================================
// API֐.
//============================================================================
// hCo[`
void SW_init(void) {
	//|[gݒ(́AvAbv)
	PORT_mode_inpu(PUSH1_PIN);
	PORT_mode_inpu(PUSH2_PIN);
	PORT_mode_inpu(PUSH3_PIN);
	PORT_mode_inpu(PUSH4_PIN);

	PORT_mode_inpu(DIPSW1_PIN);
	PORT_mode_inpu(DIPSW2_PIN);
	PORT_mode_inpu(DIPSW3_PIN);
	PORT_mode_inpu(DIPSW4_PIN);

	start_task(SW_taskid, SW_main);
}

//---------------------------------------------------------------------
// SW͒l擾.
int SW_value(void) {
	return last_data.data;
}

// SWo.
int SW_geton(int mask) {
	int i = 0;
	if (last_data.change & mask) i = last_data.data & mask;
	last_data.change &= ~mask;
	return i;
}

// SWω_擾.
int SW_change(void) {
	return last_data.change;
}

// SWω_NA.
void SW_clear(int mask) {
	last_data.change &= ~mask;
}

//============================================================================
// ^XNA又.
//============================================================================
// SW^XN(又).
void SW_main(void) {
	int i;

	i = 0;
	if (!PORT_inchkbit(PUSH1_PIN)) i+= PUSH1_MASK;
	if (!PORT_inchkbit(PUSH2_PIN)) i+= PUSH2_MASK;
	if (!PORT_inchkbit(PUSH3_PIN)) i+= PUSH3_MASK;
	if (!PORT_inchkbit(PUSH4_PIN)) i+= PUSH4_MASK;

	if (!PORT_inchkbit(DIPSW1_PIN)) i+= DIPSW1_MASK;
	if (!PORT_inchkbit(DIPSW2_PIN)) i+= DIPSW2_MASK;
	if (!PORT_inchkbit(DIPSW3_PIN)) i+= DIPSW3_MASK;
	if (!PORT_inchkbit(DIPSW4_PIN)) i+= DIPSW4_MASK;
	
	if (i == prev_code || i != prev_detect) {
		prev_detect = i;
		count = 0;
	}
	else if (++count >= SW_DETECT) {
		last_data.change = prev_code ^ i;
		last_data.data = prev_code = i;
		count = 0;
	}
	delay_task(10);
}

//============================================================================
// [J֐.
//============================================================================

//============================================================================
// nh.
//============================================================================

//============================================================================
